#ifndef _REQUEST_H_
#define _REQUEST_H_

#include <tid.h>

typedef enum {AddChannel, DelChannel} RequestType;


class TidRequest { // class for client to make requests to computation server

  std::queue<RequestType> type; // what kind of request

  std::queue<std::string> user; // user name

  std::queue<std::string> password; // user password

  std::queue<std::string> params; // parameters of the request

 public:
  TidRequest () {};
  ~TidRequest () {};
};


class Tid;

class TidBroadcast : public TidIO { // class to broadcast results to database or data server

 public:

  TidBroadcast() {};

  TidBroadcast(const TidIO &org);

  ~TidBroadcast() {};

  void SendEvent(Event* s); // push event through IOserver and data base

  void SendTableofContent(Tid* t, int); // send table of content
};

#endif
