#include <string>
#include <vector>
class ParseLine;

class VArg {
public:
  typedef std::vector<std::string> string_vector;
  typedef unsigned int const_arg_iter;
public:
  VArg(int N=0);
  VArg& operator<<(const std::string& a);
  VArg& operator=(const std::string& a);
  const std::string& operator[](const std::string& a) const;
  const_arg_iter begin(void) const;
  const_arg_iter end(void) const;
  void erase(void);
  const_arg_iter find(const std::string& a) const;
  const_arg_iter findx(const std::string& a) const;
  bool getBool(const std::string& a) const;
  double getDouble(const std::string& a) const;
  void scan(const ParseLine& pl, int first=0, int last=0);
  int scanx(const ParseLine& pl, int first, int last);
private:
  string_vector mKeyList;
  string_vector mArgList;
  std::string   mScanError;
};

inline VArg::const_arg_iter 
VArg::begin(void) const {
    return 0;
}

inline VArg::const_arg_iter 
VArg::end(void) const {
    return mKeyList.size();
}

inline bool 
VArg::getBool(const std::string& a) const {
    return (*this)[a] == "true";
}
